package nz.ac.canterbury.debugassist.datasource;

import java.util.HashSet;
import java.util.Set;

import nz.ac.canterbury.debugassist.events.DataUpdateBreakpointListener;
import nz.ac.canterbury.debugassist.pseudobreakpoint.PseudoBreakpointImpl;

public class DataBreakpointStore {
	private static DataBreakpointStore instance;
	
	private Set<PseudoBreakpointImpl> breakpoints;
	private DataBreakpointStore() { 
		breakpoints = new HashSet<PseudoBreakpointImpl>();
	}
	
	public void addBreakpoint(PseudoBreakpointImpl bp) {
		breakpoints.add(bp);
		DataUpdateBreakpointListener.getInstance().updateAll();
	}
	
	public void removeBreakpoint(PseudoBreakpointImpl bp) {
		breakpoints.remove(bp);
		DataUpdateBreakpointListener.getInstance().updateAll();
	}
	
	public Set<PseudoBreakpointImpl> getAllBreakpoints() {
		return breakpoints;
	}
	
	
	public static DataBreakpointStore getInstance() {
		if(instance == null) { instance = new DataBreakpointStore(); }
		return instance;
	}
	
	
}
