package nz.ac.canterbury.debugassist.events;

import java.util.HashSet;
import java.util.Set;

public class DataUpdateBreakpointListener {
	private static DataUpdateBreakpointListener instance;
	private Set<DataUpdateBreakpointClient> clients;
	private DataUpdateBreakpointListener() {
		clients = new HashSet<DataUpdateBreakpointClient>();
	}
	public void updateAll() {
		
		for(DataUpdateBreakpointClient c : instance.clients) {
			c.breakpointUpdateRequired();
		}
		
	}
	
	
	public void attachElement(DataUpdateBreakpointClient c) {

		clients.add(c);
	}
	
	public void detachElement(DataUpdateBreakpointClient c) {
		clients.remove(c);
	}
	
	public static DataUpdateBreakpointListener getInstance() {
		if(instance == null) { instance = new DataUpdateBreakpointListener(); }
		return instance;
	}
	
}
