package nz.ac.canterbury.debugassist.pseudobreakpoint;

import java.util.HashMap;


import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRunnable;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.DebugException;
import org.eclipse.debug.core.model.IBreakpoint;
import org.eclipse.jdt.internal.debug.core.breakpoints.JavaBreakpoint;
import org.eclipse.jdt.internal.debug.core.breakpoints.JavaLineBreakpoint;

public class PseudoBreakpointImpl extends JavaLineBreakpoint {

	public PseudoBreakpointImpl(final IResource resource, final String   typeName, final int lineNumber) throws DebugException {
         IWorkspaceRunnable wr= new IWorkspaceRunnable() {
             public void run(IProgressMonitor monitor) throws CoreException {
				
            	 
            	 //another attempt...
            	 IMarker marker = resource.createMarker("nz.ac.canterbury.debugassist.pseudobreakpoint.PseudoBreakPointMarker");
            	 setMarker(marker);
            	 HashMap attributes = new HashMap();
            	 attributes.put(IBreakpoint.ID, getModelIdentifier());
            	 attributes.put(IMarker.LINE_NUMBER, lineNumber);
            	 //attributes.put(IMarker.CHAR_START, 1);
            	 //attributes.put(IMarker.CHAR_END, 2);
            	 //attributes.put(HIT_COUNT, 0);
            	 //attributes.put(EXPIRED, false);
            	 attributes.put(IBreakpoint.ENABLED, true);
            	 attributes.put(SUSPEND_POLICY, getDefaultSuspendPolicy());
            	 attributes.put(TYPE_NAME, typeName);
            	 ensureMarker().setAttributes(attributes);
            	 register(true);
            	 
            	 
                 
            }
         };
        run(getMarkerRule(resource), wr);
   
        
    }
	@Override
	protected String getMarkerMessage(boolean conditionEnabled, String condition, int hitCount, int suspendPolicy, int lineNumber) {
		StringBuffer message = new StringBuffer(super.getMarkerMessage(hitCount, suspendPolicy));
		message.append(" - PseudoBP");
		
		return message.toString();
	}
	
	public String getCondition() {
		return "PseudoBP";
	}
	
	



}
